=== debian/changelog ===
gromacs (2021.4-2) unstable; urgency=medium

  * Cherry-pick upstream merge request 2172, widening tolerance for one
    build-time test (GammaDistributionTest.Output) that fails on a few
    architectures.

 -- Nicholas Breen <nbreen@debian.org>  Mon, 08 Nov 2021 18:00:11 -0800

gromacs (2021.4-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 06 Nov 2021 16:33:33 -0700

gromacs (2021.3-4) unstable; urgency=medium

  * Add Build-Depends-Indep: tex-gyre.  (Closes: #997067)

 -- Nicholas Breen <nbreen@debian.org>  Sat, 23 Oct 2021 11:18:36 -0700
