=== debian/rules ===
#!/usr/bin/make -f
#
# build script for GROMACS

PACKAGE := gromacs

DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_DISTRO         ?= $(shell lsb_release -si)
DEB_VERSION        ?= $(shell dpkg-parsechangelog -S version)

# add hardening flags, using dpkg-buildflags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
#653916 and http://www.cmake.org/Bug/view.php?id=12928 and https://gitlab.kitware.com/cmake/cmake/-/issues/12928
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

# DEB_BUILD_OPTIONS boilerplate.
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -Wall
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE += -j$(NUMJOBS)
endif

# General configuration options used for all builds.
COMMON_CONFIG_PARAMS = \
	$(CURDIR) \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_RULE_MESSAGES=OFF \
	-DCMAKE_INSTALL_PREFIX="/usr" \
	-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_SKIP_RPATH=ON \
	-DGMX_EXTERNAL_ZLIB=ON \
	-DGMX_VERSION_STRING_OF_FORK="$(DEB_DISTRO)-$(DEB_VERSION)" \
	-DGMX_GIT_VERSION_INFO=OFF \
	-DGMX_HWLOC=ON \
	-DGMXAPI=OFF

# Specific options for the MPI-enabled builds.
MPI_CONFIG_PARAMS = \
	-DGMX_MPI=ON \
	-DGMX_X11=OFF \
	-DGMX_DEFAULT_SUFFIX=OFF \
	-DMPIEXEC="/usr/bin/mpiexec" \
	-DGMX_BUILD_MDRUN_ONLY=ON

# For compatibility reasons, disable SIMD CPU optimizations EXCEPT
# for SSE2 on x86, SSE4.1 on amd64/x32, and NEON on arm64.
# For local compilations, set DEB_BUILD_OPTIONS=cpuopt for automatic
# detection of the best available option.
# See https://manual.gromacs.org/documentation/current/user-guide/mdrun-performance.html#intra-core-parallelization
# and https://manual.gromacs.org/documentation/current/install-guide/index.html#gmx-simd-support
ifeq (,$(findstring cpuopt,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH), i386)
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=SSE2
else ifeq ($(DEB_HOST_ARCH), amd64)
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=SSE4.1
else ifeq ($(DEB_HOST_ARCH), x32)
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=SSE4.1
else ifeq ($(DEB_HOST_ARCH), arm64)
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=ARM_NEON_ASIMD
else
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=None
endif
endif

# Include "gpu" in DEB_BUILD_OPTIONS to build GPU-accelerated binaries as well.
# This build option is not always well tested, please send comments.
# You must have the pacakges "nvidia-cuda-toolkit" and "nvidia-cuda-dev"
# installed. Those are not official build dependencies to keep the package in
# Debian main!
#
# If you use this option, it is strongly recommended that you also set
# DEB_BUILD_OPTIONS=cpuopt, assuming you are compiling and running on the same
# machine.
#
# Further details at
# https://manual.gromacs.org/documentation/current/user-guide/mdrun-performance.html#running-mdrun-with-gpus
GPU_CONFIG_PARAMS =
ifneq (,$(findstring gpu,$(DEB_BUILD_OPTIONS)))
	GPU_CONFIG_PARAMS += -DGMX_GPU=ON
endif

# Tests on RISC-V do not *build* - ICEs while compiling the embedded version
# of libtinyxml.  For the time being, bypass entirely; difficult to diagnose
# further without a riscv64 porterbox.
ifeq ($(DEB_HOST_ARCH), riscv64)
	DEB_BUILD_OPTIONS += nocheck
endif

# Improve display of build-time tests.
export GTEST_COLOR=no
export CTEST_OUTPUT_ON_FAILURE=1

#######################################################################

build: build-arch build-indep

build-arch: configure-stamp build-basic build-mpi
build-indep: build-manual

configure: configure-stamp
configure-stamp:
	dh_testdir
	(mkdir -p build/basic; cd build/basic; cmake \
	$(COMMON_CONFIG_PARAMS) $(GPU_CONFIG_PARAMS) -DGMX_MPI=OFF -DGMX_X11=ON -DGMX_INSTALL_LEGACY_API=ON )
	(mkdir -p build/basic-dp; cd build/basic-dp; cmake \
	$(COMMON_CONFIG_PARAMS) -DGMX_MPI=OFF -DGMX_X11=ON -DGMX_DOUBLE=ON)
	(mkdir -p build/mpi; cd build/mpi; CC=/usr/bin/mpicc CXX=/usr/bin/mpicxx cmake \
	$(COMMON_CONFIG_PARAMS) $(MPI_CONFIG_PARAMS) $(GPU_CONFIG_PARAMS) -DGMX_BINARY_SUFFIX="_mpi" -DGMX_LIBS_SUFFIX="_mpi")
	(mkdir -p build/mpi-dp; cd build/mpi-dp; CC=/usr/bin/mpicc CXX=/usr/bin/mpicxx cmake \
	$(COMMON_CONFIG_PARAMS) $(MPI_CONFIG_PARAMS) -DGMX_DOUBLE=ON -DGMX_BINARY_SUFFIX="_mpi_d" -DGMX_LIBS_SUFFIX="_mpi_d")
	touch $@

# Standard builds, in single and double precision.
build-basic: configure-stamp
	dh_testdir
	$(MAKE) -C build/basic
	$(MAKE) -C build/basic-dp
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C build/basic tests
	(cd build/basic;    LD_LIBRARY_PATH=$(CURDIR)/build/basic/lib    ctest -V || dpkg-architecture -i hurd-i386 )
	$(MAKE) -C build/basic-dp tests
	(cd build/basic-dp; LD_LIBRARY_PATH=$(CURDIR)/build/basic-dp/lib ctest -V || dpkg-architecture -i hurd-i386 )
endif
	touch $@

# MPI-enabled build.
build-mpi: configure-stamp
	dh_testdir
	$(MAKE) -C build/mpi
	$(MAKE) -C build/mpi-dp
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# rsh_agent: https://bugs.debian.org/494046
	# oversubscribe: https://bugs.debian.org/850229#51
	# Applicable only to OpenMPI, but no-ops on MPICH architectures
	$(MAKE) -C build/mpi tests
	(cd build/mpi ; LD_LIBRARY_PATH=$(CURDIR)/build/mpi/lib \
                        OMPI_MCA_plm_rsh_agent=/bin/false \
                        OMPI_MCA_rmaps_base_oversubscribe=1 \
                        ctest -V || dpkg-architecture -i hurd-i386 || dpkg-architecture -i x32 )
endif
	touch $@

# Documentation.
build-manual:
	dh_testdir
	# Build speedy, stripped-down version just for documentation generation.
	# Derived from (former) admin/build-docs.sh
	(mkdir -p build/documentation ; cd build/documentation; LD_LIBRARY_PATH=$(CURDIR)/build/documentation/lib \
	cmake $(CURDIR) -DCMAKE_BUILD_TYPE=Debug -DGMX_OPENMP=OFF -DGMX_SIMD=None \
	-DGMX_GPU=OFF -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_RULE_MESSAGES=OFF -DGMX_BUILD_MANUAL=ON \
	-DGMX_BUILD_HELP=ON -DGMX_VERSION_STRING_OF_FORK="$(DEB_DISTRO)-$(DEB_VERSION)")
	$(MAKE) gmx -C build/documentation
	# Generate PDF
	$(MAKE) manual -C build/documentation
	# Generate man pages
	$(MAKE) man -C build/documentation
	# Generate HTML
	$(MAKE) webpage -C build/documentation

# install-basic and install-mpi fire before the main "install" target.
install-basic: build-arch
	dh_testdir
	dh_testroot
	dh_prep -pgromacs
	dh_installdirs -pgromacs

	$(MAKE) -C build/basic install DESTDIR=$(CURDIR)/debian/gromacs
	$(MAKE) -C build/basic-dp install DESTDIR=$(CURDIR)/debian/gromacs

	dh_installman -pgromacs debian/man/demux.1 debian/man/xplor2gmx.1
	# gmx(1) -> gmx_d(1)
	dh_link -pgromacs -pgromacs-data

install-mpi: build-mpi
	dh_testdir
	dh_testroot
	dh_prep -pgromacs-mpi
	dh_installdirs -pgromacs-mpi

	$(MAKE) -C build/mpi    install DESTDIR=$(CURDIR)/debian/gromacs-mpi
	$(MAKE) -C build/mpi-dp install DESTDIR=$(CURDIR)/debian/gromacs-mpi

	# overlapping include files with libgromacs-dev: can probably remove when old API is removed
	rm -rf $(CURDIR)/debian/gromacs-mpi/usr/include

	chmod 644 $(CURDIR)/debian/gromacs-mpi/usr/bin/gmx-completion*
	mv $(CURDIR)/debian/gromacs-mpi/usr/bin/gmx-completion-mdrun_mpi.bash $(CURDIR)/debian/gromacs-mpi/usr/share/bash-completion/completions/mdrun_mpi
	mv $(CURDIR)/debian/gromacs-mpi/usr/bin/gmx-completion-mdrun_mpi_d.bash $(CURDIR)/debian/gromacs-mpi/usr/share/bash-completion/completions/mdrun_mpi_d

	dh_installman -pgromacs-mpi debian/man/mdrun_mpi.1
	dh_link -pgromacs-mpi usr/share/man/man1/mdrun_mpi.1.gz usr/share/man/man1/mdrun_mpi_d.1.gz
	dh_lintian -pgromacs-mpi

# Rules in this target largely handle the library packages and arch-indep data (but not documentation).
install: build-arch install-basic install-mpi
	dh_testdir
	dh_testroot
	dh_prep -pgromacs-data -plibgromacs-dev -plibnblib-dev
	dh_installdirs -pgromacs-data

	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/top \
